﻿using System;
using System.Collections.Generic;
using Rhino;
using Rhino.Commands;
using Rhino.Geometry;
using Rhino.Input;
using Rhino.Input.Custom;

namespace RuiUpdateMenuItem
{
  public class RuiUpdateMenuItemCommand : Command
  {
    public RuiUpdateMenuItemCommand()
    {
      // Rhino only creates one instance of each command class defined in a
      // plug-in, so it is safe to store a refence in a static property.
      Instance = this;
    }

    ///<summary>The only instance of this command.</summary>
    public static RuiUpdateMenuItemCommand Instance
    {
      get; private set;
    }

    ///<returns>The command name as it appears on the Rhino command line.</returns>
    public override string EnglishName
    {
      get { return "RuiUpdateMenuItem"; }
    }

    protected override Result RunCommand(RhinoDoc doc, RunMode mode)
    {
      RuiUpdateMenuItemPlugIn.Instance.BoolTest = !RuiUpdateMenuItemPlugIn.Instance.BoolTest;
      RhinoApp.WriteLine($"BoolTest value toggled, current value: {RuiUpdateMenuItemPlugIn.Instance.BoolTest}");
      return Result.Success;
    }
  }
}
