﻿using Rhino;
using Rhino.PlugIns;
using System;

namespace RuiUpdateMenuItem
{
  ///<summary>
  /// <para>Every RhinoCommon .rhp assembly must have one and only one PlugIn-derived
  /// class. DO NOT create instances of this class yourself. It is the
  /// responsibility of Rhino to create an instance of this class.</para>
  /// <para>To complete plug-in information, please also see all PlugInDescription
  /// attributes in AssemblyInfo.cs (you might need to click "Project" ->
  /// "Show All Files" to see it in the "Solution Explorer" window).</para>
  ///</summary>
  public class RuiUpdateMenuItemPlugIn : Rhino.PlugIns.PlugIn

  {
    public RuiUpdateMenuItemPlugIn()
    {
      Instance = this;
    }

    ///<summary>Gets the only instance of the RuiUpdateMenuItemPlugIn plug-in.</summary>
    public static RuiUpdateMenuItemPlugIn Instance
    {
      get; private set;
    }

    protected override LoadReturnCode OnLoad(ref string errorMessage)
    {
      Rhino.UI.RuiUpdateUi.RegisterMenuItem(RuiId, MenuId, MenuItemId, UpdateMenuItem);

      return base.OnLoad(ref errorMessage);
    }

    Guid RuiId { get; } = new Guid("9a53deb7-05ac-440f-b37c-4214fad16913");
    Guid MenuId { get; } = new Guid("d58ceae7-fdb0-4104-80da-274b94ad44a9");
    Guid MenuItemId { get; } = new Guid("788f02ff-2ff6-47b3-af87-f09aa5839e13");


    void UpdateMenuItem(object sender, Rhino.UI.RuiUpdateUi cmdui)
    {
      if (cmdui.MenuId == MenuId && cmdui.MenuItemId == MenuItemId)
        cmdui.Checked = BoolTest;
    }

    public bool BoolTest
    {
      get => !Settings.TryGetBool(nameof(BoolTest), out bool b) || b;
      set => Settings.SetBool(nameof(BoolTest), value);
    }

    // You can override methods here to change the plug-in behavior on
    // loading and shut down, add options pages to the Rhino _Option command
    // and maintain plug-in wide options in a document.
  }
}